/*
 define serial port
  copyright(C) T.Satoh  mail:T-Satoh@NetLaputa.ne.jp

usage
1)define serial I/O bit
  ex.
	bit RS232_OUTBIT @ PORTB.0;
	bit RS232_INPBIT  @ PORTB.0;
2)define SERIAL_POLARITY
  when using level converter, set 1
  else(connect direct) set 0 for send and receive
  ex.
    #define SERIAL_SND_POLARITY	1
    #define SERIAL_RCV_POLARITY	0
3)if same bit allocated to IN/OUT,
  define I/O change statement
  ex.
    #define RS232C_SET_INP TRISB.0=1;
    #define RS232C_SET_OUT TRISB.0=0;
4)define SIO_BIT_TIM to set speed
  19.2Kbps -> 52us/bit
  clock  speed value
  4MHz   19.2K   14


ex.(total setting)
bit RS232_OUTBIT @ PORTB.0;
bit RS232_INPBIT  @ PORTB.0;
#define SERIAL_SND_POLARITY	1
#define SERIAL_RCV_POLARITY	0
#define RS232C_SET_INP TRISB.0=1;
#define RS232C_SET_OUT TRISB.0=0;
#define SIO_BIT_TIM 14
#include "sio1bitdriver.c"

 note:
  when Interrupt is enable, SioPutchar() and SioGetchar()
  functions set interrupt disable at first, and set enable
  at last with GIE bit.
*/

#define SW_SERIAL	// if use software sreial then define

#ifdef SW_SERIAL

bit RS232_OUTBIT @ PORTA.7;
bit RS232_INPBIT  @ PORTA.7;
#define SERIAL_SND_POLARITY	1
#define SERIAL_RCV_POLARITY	0
#define RS232C_SET_INP TRISA.7=1;
#define RS232C_SET_OUT TRISA.7=0;
#define SIO_BIT_TIM 14
#define SERIAL_SPEED	2	// 1:9600, 2:19200, 3:38400
#define SET_ANASEL	nop();	// ΉrbgAiO͂̏ꍇAANASEL0ɂ

#else

#define SERIAL_SPEED	1	// 1:9600, 2:19200, 3:38400

#endif
